@/data/kbah/code/FGF/fulldisk/sub_pro/READ_ABI_NETCDF_01.PRO
@/data/kbah/code/FGF/fulldisk/sub_pro/WRITE_VAL_FROM_GRB_SCALED_NETCDF.PRO
@/data/kbah/code/FGF/fulldisk/sub_pro/WRITE_GRB_SCALED_NETCDF.PRO
@/data/kbah/code/FGF/fulldisk/sub_pro/SUBSET_DATA.PRO


PRO FULLDISK_NETCDF_GRB_VAL_NETCDF_FGF
 
 ;;;;;Variables  
    inpre0='/data/kbah/input_data/FGF/fulldisk/'
    outpreg='/data/kbah/output/FGF/fulldisk/GRB/' 
    outprev='/data/kbah/output/FGF/fulldisk/VAL/' 
     
     times=['2200']
     
     FOR ii=11 , 11 DO BEGIN  ;7 ,16
          inpre=inpre0 & bnum=STRING(STRTRIM(ii,1))
    
          IF ii LT 10 THEN bnum='0'+ STRING(STRTRIM(ii,1))
                aband=STRING('band'+bnum)

                nt=n_elements(times)
          for ntime=0,nt-1 do begin
               time=times(ntime)
               outpre1= outpreg &  outpre2= outprev    
              infiles=GET_FILES(inpre=inpre, aband=aband, time=time, ii=ii)
              MAKE_BANDLOOP,infiles, outpre1, outpre2, num_files,ii
           endfor
  ENDFOR  
  
END




  ;;;;;;;;;;;;;;;sub routines
  
  
  
FUNCTION READ_FILES,infiles,latlonfile, vars=vars
  data=READ_ABI_NETCDF_01(infiles,vars=vars, nvars=1, lineele=0)
  latlon=READ_ABI_NETCDF_01(latlonfile,vars=vars, xx=5534, yy=1, nvars=2, lineele=1) 
  datalatlon={data:data, latlon:latlon}
 RETURN, datalatlon 
END


FUNCTION GET_FILES,inpre=inpre, aband=aband, time=time, ii=ii
  IF not keyword_set(inpre) then message, 'Provide input file location'
  IF not keyword_set(aband) then message, 'Provide the band number to process'
  
    inpre2='ncsa/' ;psc/' ;ncsa'2km/'
    inprele='lineelements/'
    ;IF (ii LE 5 AND ii NE 4) THEN inpre2='' ;'1km/'
    inpred=inpre+inpre2  & inprele=inpre+inprele
    sub1='*'+aband+'*'+time+'*' & sub2='*137W_lines_elements*'   
    
    datafiles=FIlE_SEARCH(inpred, sub1)
    print,datafiles
    lineselements=FILE_SEARCH(inprele,sub2)
    info={data:datafiles, lineselements:lineselements}
    RETURN, info
END






PRO MAKE_BANDLOOP,infiles, outpre1,outpre2, num_files,ii
     tot_newfiles=N_ELEMENTS(infiles.data)
     IF (tot_newfiles GE 1) THEN BEGIN  
     FOR jj=0, tot_newfiles-1 DO BEGIN  ;tot_newfiles-1
        spos=STRPOS(infiles.data(jj),'ncsa_',  /REVERSE_SEARCH) ;'psc_'
        epos=STRPOS(infiles.data(jj), '.',    /REVERSE_SEARCH) 
        ;outpost=STRMID(infiles.data(jj), spos-9, (epos+12-spos))
        outpost=STRMID(infiles.data(jj), spos, (epos+3-spos))
        outpre1=outpre1+'GRB_scaled_'+ outpost  
        outpre2=outpre2+'Validation_'+ outpost

        vars=0
        IF (ii LE 6) THEN var=1
  
     data=READ_FILES(infiles.data(jj), infiles(0).lineselements,vars=vars)
    multivar=0
    WRITE_GRB_SCALED_NETCDF,data, outpre1, ii, multivar,katr
    WRITE_VAL_FROM_GRB_SCALED_NETCDF, outpre1, outpre2, ii, multivar,katr,infiles(0).lineselements

          print,  '   ' ;ii, jj
          print,  '   ' ;ii, jj
          print,  'DONE   ' ;ii, jj
  ENDFOR
  ENDIF 
END
