
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

 PRO print_netcdf, data,latlon, outputplot, limit, bb
;POR print_netcdf,     data,latloninfo,landmask,outputplot, in, bb
	wminlat=17.51429 & wmaxlat=54.53548  & wminlon=-152.85651 & wmaxlon=-92.719963
	

	
	IF (bb LE 3) THEN BEGIN
		
		nc_outpre='/media/My Book/data/band-diff-netcdf/awips/'
		 IF (bb NE 0) THEN nc_post='single-diff/' ELSE nc_post='bands'

		IF (bb EQ 1) THEN sub_folder='full-range/'
		IF (bb EQ 3) THEN sub_folder='focused-range/'
		IF (bb EQ 0) THEN sub_folder='/'

		start_pos=STRPOS(outputplot,'/',    /REVERSE_SEARCH)
		end_pos=STRPOS(outputplot, '.',    /REVERSE_SEARCH) 
		
		chkpt= STRMID(outputplot,STRPOS(outputplot,'_BAND')+6, 1)
		IF (chkpt EQ '_') THEN BEGIN
			bfolder= 'BANDS'+STRMID(outputplot,STRPOS(outputplot,'_BAND')+7, 5)
		ENDIF ELSE BEGIN
			bfolder=STRMID(outputplot,STRPOS(outputplot,'_BAND')+1, 10)
		ENDELSE
		IF (bb EQ 0) THEN bfolder='band'+ STRMID(outputplot,STRPOS(outputplot,'_band')+5, 2)

		dyear=STRMID(outputplot,end_pos-9, 4)
		dmonth=STRMID(outputplot,end_pos-15, 2)
		dday=STRMID(outputplot,end_pos-12, 2)
		dtime=STRMID(outputplot,end_pos-4, 4)
		afname=STRMID(outputplot,start_pos+1, end_pos-start_pos)

		IF (bb EQ 0) THEN BEGIN
			dyear=STRMID(outputplot,end_pos-17, 4)
			dmonth=STRMID(outputplot,end_pos-12, 2)
			dday=STRMID(outputplot,end_pos-10, 2)
			dtime=STRMID(outputplot,end_pos-7, 4)
		ENDIF
                ncoutfile= STRING(nc_outpre)+ STRING(nc_post)+ STRING(sub_folder)+ STRING(bfolder)+'/'+STRING(dyear)+STRING(dmonth)+STRING(dday)+'_'+STRING(dtime)  ;+'.nc'
	 	 
		 cdfid=ncdf_create(ncoutfile, /clobber)

		;wconus = WHERE((latlon.dataset[0].data GE wminlat AND latlon.dataset[0].data LE wmaxlat) AND $
                ;  	 (latlon.dataset[1].data GE wminlon AND latlon.dataset[1].data LE wmaxlon),count)
		; westconus=data.data(wconus)
		;tempdata=CONGRID(westconus, xx,yy)
		;tempdata= sin(data.data)  ;TRI_SURF(data.data, data.data(1:2653,*), data.data(*,1:1221), NX=2600, NY=1222)
		



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		miss=0 & limit=[17.51429,-152.8565,54.53548,-92.71996] & xxx=1327 & yyy=1222  ;[20,-125,55,-60] ;

		g_pt = WHERE((latlon.dataset[0].data GE limit[0] AND latlon.dataset[0].data LE limit[2]) AND $
                  	 (latlon.dataset[1].data GE limit[1] AND latlon.dataset[1].data LE limit[3]),count1)

                
;		tdata=FLTARR(xxx, yyy) & tlat=FLTARR(xxx,yyy) &  tlon=FLTARR(xxx,yyy) 
;		FOR ww=0, xxx-1 DO BEGIN
;			FOR vv=0, yyy-1 DO BEGIN
; 				;IF (ww EQ 0) THEN pt=vv ELSE pt=
;				 tdata(ww,vv)=data.data(ww,vv)
;				 tlat(ww,vv)=latlon.dataset[0].data(ww,vv)
;				 tlon(ww,vv)=latlon.dataset[1].data(ww,vv)
;			ENDFOR
;		ENDFOR	

		tdata=data(g_pt) ;.data(g_pt)
		tlat=latlon.dataset[0].data(g_pt)
		tlon=latlon.dataset[1].data(g_pt)

		newdata=newimagemap2(tdata, tlat, tlon, miss, lambert)  ;limit,, /noerase,/noborder) 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		
               ;  newdata2=CONGRID(newdata, 2654, 1222)

		ww=size(newdata, /dimensions)
	
		yy=LONG(ww(0))   
		xx=LONG(ww(1))  


		 ydimid =ncdf_dimdef(cdfid, 'y', yy)  
		 xdimid =ncdf_dimdef(cdfid, 'x', xx)      
		 
		 		 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; netcdf  mcdias/abi org. format               ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;		 varid= ncdf_vardef(cdfid, STRING(data.headinfo.var), [ydimid, xdimid], /float)
;		 ncdf_attput, cdfid, varid, STRING(data.headinfo.attr(0)), STRING(in.nctitle)
;		 FOR s=1, data.headinfo.nvarsatt-1 DO BEGIN 
;			;IF ((s EQ 2) OR (s EQ 4))THEN varval=data.headinfo.attrval(s) ELSE varval=STRING(data.headinfo.attrval(s))
;			 ncdf_attput, cdfid, varid, STRING(data.headinfo.attr(s)), STRTRIM(data.headinfo.attrval(s),1)  ;varval
;		 ENDFOR
;
;		 FOR t=0, data.headinfo.ngats-3 DO BEGIN
;			ncdf_attput, cdfid, data.headinfo.gats(t).name, STRTRIM(data.headinfo.gats(t).value, 1), /global
;			;IF (t EQ 9) THEN ncdf_attput, cdfid, 'BAND-DIFF/NDVI', 'Kaba Bah', /global
;		 ENDFOR
;       		 ncdf_attput, cdfid, 'BAND_DIFF_AUTHOR', 'KABA BAH', /global
;		 ncdf_attput, cdfid, 'CEN_LAT', 37.34798, /global
;		 ncdf_attput, cdfid, 'CEN_LON', -96.587105, /global
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; AIPS netCDF format 	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
			
		;;;variables
		
		
 		 varid= ncdf_vardef(cdfid, 'validTime', /double)
		 ncdf_attput, cdfid, varid, 'units' , 'Seconds since 1970-1-1 00:00:00.00 0:00'
		 
		 varid= ncdf_vardef(cdfid, 'image', [xdimid, ydimid], /byte)
		 ncdf_attput, cdfid, varid, 'long_name' , 'image'

		;;;global variables
		ncdf_attput, cdfid, 'depictorName', 'westConus' , /global
		ncdf_attput, cdfid, 'projName','LAMBERT_CONFORMAL', /global
		ncdf_attput, cdfid, 'projIndex',LONG(3), /global
		ncdf_attput, cdfid, 'lat00', 54.53548, /global
                ncdf_attput, cdfid, 'lon00', -152.85651 , /global
                ncdf_attput, cdfid, 'latNxNy', 17.51429 , /global
                ncdf_attput, cdfid, 'lonNxNy', -92.719963,/global
                ncdf_attput, cdfid, 'centralLat',   25. ,/global
                ncdf_attput, cdfid, 'centralLon',  -95. ,/global
                ncdf_attput, cdfid, 'latDxDy', 39.25658 ,/global
                ncdf_attput, cdfid, 'lonDxDy',-117.4858 ,/global
                ncdf_attput, cdfid, 'dyKm',  3.9315109  ,/global
                ncdf_attput, cdfid, 'dxKm',  3.932111   ,/global
                ncdf_attput, cdfid, 'rotation', 25.     ,/global
                ncdf_attput, cdfid, 'xMin', -0.2556496  ,/global
                ncdf_attput, cdfid, 'xMax',  0.01474848 ,/global
                ncdf_attput, cdfid, 'yMin', -0.87687713 ,/global
                ncdf_attput, cdfid, 'yMax', -0.56223971 ,/global

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;		;tempdata= ROTATE(tempdata,3)
	   
               z=SIZE(newdata, /DIMENSIONS)
		x1=((z[0]/2)-147.5) ;   (+left/down awips  to -right/up awips)
		y1=((z[1]/2)+295.0) ;   (up to -down)
		
         
		 newdata=TRANSPOSE(newdata)
		 newdata=ROT(newdata, 89.98, 1.143, x1,y1 )   ; /INTERP, CUBIC=-0.5)   ;tempdata=ROTATE(tempdata,4)   ;  ;tempdata =SHIFT(tempdata,1)  ;        
	       
		
		
		; cc= where(newdata EQ min(newdata))
		 ;newdata(cc)=10


		 ncdf_control, cdfid, /endef
		 ncdf_varput, cdfid, varid, newdata ;westconus ;new_data 
		 ncdf_close, cdfid
		
		;print, ncoutfile
		Print, 'netCDF file is made'
	ENDIF
	        
END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
